#ifndef __MSScriptControl_inc__
#define __MSScriptControl_inc__

#ifndef __objbase_inc__
#include "objbase.inc"
#endif
//#use "ocx\\MSScriptControl.lib"

// Library MSScriptControl
// Microsoft Script Control 1.0
// InprocServer32: C:\WINDOWS\system32\msscript.ocx
// ProgID: MSScriptControl.ScriptControl.1	clsid: {0E59F1D5-1FBE-11D0-8FF2-00A0D10038BC}

enum ScriptControlStates
{
	Initialized = 0,
	Connected = 1
}

//////////////////////////////////
// module ScriptControlConstants
#define GlobalModule L"Global"
#define NoTimeout -1

// {70841C73-067D-11D0-95D8-00A02463AB28}
//extern _IID_IScriptProcedure as GUID;

interface IScriptProcedure : IDispatch
{
	declare virtual get_Name(BSTR* ppRetval),HRESULT;
	declare virtual get_NumArgs(long* ppRetval),HRESULT;
	declare virtual get_HasReturnValue(VARIANT_BOOL* ppRetval),HRESULT;
}


// {70841C71-067D-11D0-95D8-00A02463AB28}
//extern _IID_IScriptProcedureCollection as GUID;

interface IScriptProcedureCollection : IDispatch
{
	declare virtual get__NewEnum(IUnknown* ppRetval),HRESULT;
	declare virtual get_Item(VARIANT Index byval, IScriptProcedure* ppRetval),HRESULT;
	declare virtual get_Count(long* ppRetval),HRESULT;
}


// {70841C70-067D-11D0-95D8-00A02463AB28}
//extern _IID_IScriptModule as GUID;

interface IScriptModule : IDispatch
{
	declare virtual get_Name(BSTR* ppRetval),HRESULT;
	declare virtual get_CodeObject(IDispatch* ppRetval),HRESULT;
	declare virtual get_Procedures(IScriptProcedureCollection* ppRetval),HRESULT;
	declare virtual AddCode(BSTR Code),HRESULT;
	declare virtual Eval(BSTR Expression, VARIANT* ppRetval),HRESULT;
	declare virtual ExecuteStatement(BSTR Statement),HRESULT;
	declare virtual Run(BSTR ProcedureName, SAFEARRAY/*VARIANT*/* Parameters, VARIANT* ppRetval),HRESULT;
}


// {70841C6F-067D-11D0-95D8-00A02463AB28}
//extern _IID_IScriptModuleCollection as GUID;

interface IScriptModuleCollection : IDispatch
{
	declare virtual get__NewEnum(IUnknown* ppRetval),HRESULT;
	declare virtual get_Item(VARIANT Index byval, IScriptModule* ppRetval),HRESULT;
	declare virtual get_Count(long* ppRetval),HRESULT;
	declare virtual Add(BSTR Name, /*[in][opt]*/opt VARIANT* Object, IScriptModule* ppRetval),HRESULT;
}


// {70841C78-067D-11D0-95D8-00A02463AB28}
//extern _IID_IScriptError as GUID;

interface IScriptError : IDispatch
{
	declare virtual get_Number(long* ppRetval),HRESULT;
	declare virtual get_Source(BSTR* ppRetval),HRESULT;
	declare virtual get_Description(BSTR* ppRetval),HRESULT;
	declare virtual get_HelpFile(BSTR* ppRetval),HRESULT;
	declare virtual get_HelpContext(long* ppRetval),HRESULT;
	declare virtual get_Text(BSTR* ppRetval),HRESULT;
	declare virtual get_Line(long* ppRetval),HRESULT;
	declare virtual get_Column(long* ppRetval),HRESULT;
	declare virtual Clear(),HRESULT;
}


// {0E59F1D3-1FBE-11D0-8FF2-00A0D10038BC}
//extern _IID_IScriptControl as GUID;

interface IScriptControl : IDispatch
{
	//Language engine to use
	declare virtual get_Language(BSTR* ppRetval),HRESULT;
	declare virtual put_Language(BSTR rhs),HRESULT;
	//State of the control
	declare virtual get_State(ScriptControlStates* ppRetval),HRESULT;
	declare virtual put_State(ScriptControlStates rhs),HRESULT;
	//hWnd used as a parent for displaying UI
	declare virtual put_SitehWnd(long rhs),HRESULT;
	declare virtual get_SitehWnd(long* ppRetval),HRESULT;
	//Length of time in milliseconds that a script can execute before being considered hung
	declare virtual get_Timeout(long* ppRetval),HRESULT;
	declare virtual put_Timeout(long rhs),HRESULT;
	//Enable or disable display of the UI
	declare virtual get_AllowUI(VARIANT_BOOL* ppRetval),HRESULT;
	declare virtual put_AllowUI(VARIANT_BOOL rhs),HRESULT;
	//Force script to execute in safe mode and disallow potentially harmful actions
	declare virtual get_UseSafeSubset(VARIANT_BOOL* ppRetval),HRESULT;
	declare virtual put_UseSafeSubset(VARIANT_BOOL rhs),HRESULT;
	//Collection of modules for the ScriptControl
	declare virtual get_Modules(IScriptModuleCollection* ppRetval),HRESULT;
	//Object exposed by the scripting engine that contains methods and properties defined in the code added to the global module
	declare virtual get_Error(IScriptError* ppRetval),HRESULT;
	//Collection of procedures that are defined in the global module
	declare virtual get_CodeObject(IDispatch* ppRetval),HRESULT;
	declare virtual get_Procedures(IScriptProcedureCollection* ppRetval),HRESULT;
	declare virtual _AboutBox(),HRESULT;
	//Add an object to the global namespace of the scripting engine
	declare virtual AddObject(BSTR Name, IDispatch* Object, /*[in][opt]*/opt VARIANT_BOOL AddMembers = VARIANT_FALSE),HRESULT;
	//Reset the scripting engine to a newly created state
	declare virtual Reset(),HRESULT;
	//Add code to the global module
	declare virtual AddCode(BSTR Code),HRESULT;
	//Evaluate an expression within the context of the global module
	declare virtual Eval(BSTR Expression, VARIANT* ppRetval),HRESULT;
	//Call a procedure defined in the global module
	declare virtual ExecuteStatement(BSTR Statement),HRESULT;
	declare virtual Run(BSTR ProcedureName, SAFEARRAY/*VARIANT*/* Parameters, VARIANT* ppRetval),HRESULT;
}


// {8B167D60-8605-11D0-ABCB-00A0C90FFFC0}
//extern _DIID_DScriptControlSource as GUID;

interface DScriptControlSource : IDispatch
{
	declare virtual Error(),HRESULT;
	declare virtual Timeout(),HRESULT;
}


// {0E59F1DA-1FBE-11D0-8FF2-00A0D10038BC}
//extern _CLSID_Procedure as GUID;
// interface IScriptProcedure

// {0E59F1DB-1FBE-11D0-8FF2-00A0D10038BC}
//extern _CLSID_Procedures as GUID;
// interface IScriptProcedureCollection

// {0E59F1DC-1FBE-11D0-8FF2-00A0D10038BC}
//extern _CLSID_Module as GUID;
// interface IScriptModule

// {0E59F1DD-1FBE-11D0-8FF2-00A0D10038BC}
//extern _CLSID_Modules as GUID;
// interface IScriptModuleCollection

// {0E59F1DE-1FBE-11D0-8FF2-00A0D10038BC}
//extern _CLSID_Error as GUID;
// interface IScriptError

// {0E59F1D5-1FBE-11D0-8FF2-00A0D10038BC}
//extern _CLSID_ScriptControl as GUID; // [control][cancreate]
// interface IScriptControl
// dispinterface DScriptControlSource

#endif
